<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>

<table>
    <thead>
    <tr>
        <th>Vorname</th>
        <th>Nachname</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <td>David</td>
        <td>Schwarz</td>
    </tr>
    <tr>
        <td>Max</td>
        <td>Muster</td>
    </tr>
    <tr>
        <td>Maria</td>
        <td>Huber</td>
    </tr>
    </tbody>
</table>

<form id="addPersonForm">
    <input type="text" id="firstNameInput" placeholder="Vorname" name="firstName" required>
    <input type="text" id="lastNameInput" placeholder="Nachname" name="lastName" required>
    <input type="number" id="birthYearInput" placeholder="Geburtsjahr" name="birthYear" required>
    <input type="email" id="emailInput" placeholder="E-Mail Adresse" maxlength="10" name="email" required>
    <button>Hinzufügen</button>
</form>

<script>
    //const firstNameInput = document.getElementById('firstNameInput')
    const firstNameInput = document.querySelector('#firstNameInput')
    const lastNameInput = document.getElementById('lastNameInput')
    const birthYearInput = document.getElementById('birthYearInput')
    const addPersonForm = document.getElementById('addPersonForm')

    const persons = [
        createPersonObject('David', 'Schwarz', 1234),
        createPersonObject('Max', 'Muster', 2345),
        createPersonObject('Maria', 'Huber', 3456)
    ]

    function createPersonObject(firstName, lastName, birthYear) {
        return {
            firstName,
            lastName,
            birthYear,
            get age() {
                return new Date().getFullYear() - this.birthYear
            },
            set fullName(fullName) {
                const nameParts = fullName.split(" ");
                this.firstName = nameParts[0]
                this.lastName = nameParts[1]
            },
            /*save: function () {
                console.log('saving person', this)
            }*/
            save() {
                console.log('saving person', this)
            }
        }
    }

    if(addPersonForm) {
        addPersonForm.addEventListener('submit', function (event) {
            event.preventDefault()
            console.log(event)
            const newFirstName = firstNameInput.value
            const newLastName = lastNameInput.value
            const newBirthYear = birthYearInput.value

            if (newFirstName && newLastName && newBirthYear) {
                persons.push(createPersonObject(newFirstName, newLastName, newBirthYear))
                console.log(persons)

                for (let i = 0; i < persons.length; i++) {
                    console.log(persons[i].firstName.toUpperCase())
                    console.log(persons[i].lastName.toUpperCase())
                    console.log(persons[i].birthYear)
                    console.log(persons[i].age)
                    persons[i].fullName = "Herbert Huber"
                    console.log(persons[i].fullName)
                    console.log(persons[i].save())
                }
            }
        })
    }

    const filteredPersons = persons.filter(person => person.firstName.startsWith("M"))
    console.log(filteredPersons)

    const personNames = persons.map(person => person.firstName + ' ' + person.lastName)
    console.log(personNames)

    console.log(persons)



    const product = {
        name: "Hemd",
        price: 20,
        ratings: [
            {
                rating: 4,
                userId: 1
            },
            {
                rating: 2,
                userId: 2
            },
            {
                rating: 4,
                userId: 3
            },
            {
                rating: 3,
                userId: 4
            }
        ],
        get averageRating() {
            let ratingSum = 0;
            for(let rating of this.ratings) {
                ratingSum += rating.rating
            }
            return ratingSum / this.ratings.length
        }
    }

    console.log(product)
</script>

</body>
</html>
